GFX		.equ	0x60

GFX_REG		.equ	0x03

INIT_DOME:
	XOR	A	; 2=MIXMODE
	OUT	(0x6F),A
	OUT	(0x67),A	; P7: MSC + POWER OFF + INT CLK

	LD	A,#6	; SETREG see page: 80
	OUT	(0x64),A
	LD	A,#0b10011010	; R6: DSPM1,DSPM0,DCKM1,DCKM0,XIMM1,XIMM0,CLRM1,CLRM0 = BITMAP + XTAL/2 + 1024px X space + 8b per dot
	OUT	(GFX+GFX_REG),A
	LD	A,#0b00001000	; R7: 0,C25M,SM1,SM,PAL,EO,IL,HSCN = !B6,262line,?,PAL,none,none-inter,none-high-scn
	OUT	(GFX+GFX_REG),A
	LD	A,#0b10000010	; R8: DISP,SPD,YSE,VWTE,VWM,DMAE,VSL1,VSL0 = VRAM+SPRITE+no-YS+512KB mem
	OUT	(0x63),A

	; mode B3: 512x212 in 1024x512 space

	; note;
	; YJK = NTSC
	; YUV = PAL

	LD	A,#13
	OUT	(0x64),A
	LD	A,#0b01000000	; R13: PLTM1,PLTM0,YAE,PLTAIH,PLT05,PLT04,PLT03,PLT02 = 256  COLOR-MODE
	OUT	(0x63),A

INIT_DOME_W0:
	IN	A,(0x65)
	AND	#64
	JR	NZ,INIT_DOME_W0
INIT_DOME_W1:
	IN	A,(0x65)
	AND	#64
	JR	Z,INIT_DOME_W1

	LD	A,#17
	OUT	(0x64),A
	XOR	A	; LIJN 0 ( MOET OP V-INT) 
	LD	B,#8
INIT_SCR_NUL_LP:
	OUT	(0x63),A	; ALLES OP 0
	DJNZ	INIT_SCR_NUL_LP

	CALL	INIT_PALLET
	CALL	MSX_DRV
	CALL	INIT_GRAF
	CALL	D_FIELD

	LD	D,#10+192	; X VIEW PORT
	LD	E,#10+8		; Y
	CALL	CHK_LEMOUSE_RAD	

	LD	HL,#CURSOR_SP
	CALL	TYPE_SP0
	LD	HL,#RADAR_SP
	CALL	TYPE_SP1
	LD	A,(VIEW_Y)
	ADD	A,#8
	LD	C,A
	LD	A,(VIEW_X)
	ADD	A,#192
	LD	B,A
	CALL	PUTSPRITE1
	LD	BC,#0x6464
	CALL	PUTSPRITE0
	CALL	INIT_RADAR
	CALL	INIT_MOUSE

	LD	HL,#INT_DOS
	CALL	GET_INT
	LD	HL,#INT_DOME
	CALL	PUT_INT

	LD	HL,#0x4000
	LD	BC,#4096*2
VELD_LOOP1:
	LD	A,#255
	LD	(HL),A
	INC	HL
	INC	HL
	XOR	A
	LD	(HL),A
	LD	A,B
	OR	C
	JR	Z,INIT_TANKS1
	INC	HL
	INC	HL
	DEC	BC
	JR	VELD_LOOP1

INIT_TANKS1:
	EI
	LD	D,#1
	LD	IX,#TANK1+16
	LD	B,#254
INIT_TANK_LOOP:
	PUSH	BC

	LD	A,0(IX)	;X
	OR	A
	JR	Z,INIT_TANK_LP_CONT
	LD	B,A
	LD	C,1(IX)	;Y
	
	PUSH	DE
	CALL	CALC_ADR
	POP	DE
	INC	HL
	LD	(HL),D		;TNK NUM

INIT_TANK_LP_CONT:
	INC	D

	LD	BC,#16
	ADD	IX,BC

	POP	BC
	DJNZ	INIT_TANK_LOOP

	CALL	MAKE_RADAR

	RET

;=============

INIT_GRAF:
	LD	HL,#CLS	; clear screen
	CALL	DO_CMD
	EI

	LD	HL,#D_VELD	; UNITS
	LD	BC,#256	; X
	LD	DE,#0	; Y
	CALL	L_GFX

	LD	HL,#D_ALL	; UNITS
	LD	BC,#256	; X
	LD	DE,#256	; Y
	CALL	L_GFX

	LD	HL,#D_ASCII
	LD	BC,#256
	LD	DE,#512
	CALL	L_GFX

	RET

;--------------------------------



INIT_PALLET:
	LD	A,#14
	OUT	(0x64),A
	XOR	A
	OUT	(0x63),A	; COLOR #0    ( R 14 )  
	OUT	(0x61),A
	OUT	(0x61),A
	OUT	(0x61),A

	OUT	(0x63),A	; BACK COLOR  ( R15 )  

	LD	A,#14
	OUT	(0x64),A
	LD	A,#1*4
	OUT	(0x63),A	; COLOR #1    ( R 14 ) 
	LD	A,#0x1F
	OUT	(0x61),A
	OUT	(0x61),A
	OUT	(0x61),A

	LD	A,#14
	OUT	(0x64),A
	LD	A,#2*4
	OUT	(0x63),A	; COLOR #2    ( R 14 ) 
	LD	A,#0x1F
	OUT	(0x61),A
	XOR	A
	OUT	(0x61),A
	OUT	(0x61),A

	LD	A,#14
	OUT	(0x64),A
	LD	A,#3*4
	OUT	(0x63),A	; COLOR #3    ( R 14 ) 
	XOR	A
	OUT	(0x61),A
	LD	A,#0x1F
	OUT	(0x61),A
	XOR	A
	OUT	(0x61),A

	LD	A,#14
	OUT	(0x64),A
	LD	A,#4*4
	OUT	(0x63),A	; COLOR #4    ( R 14 ) 
	XOR	A
	OUT	(0x61),A
	OUT	(0x61),A
	LD	A,#0x1F
	OUT	(0x61),A

	RET

;-------------------------------------------------------------------------------
; INIT

INIT_MOUSE:
	LD	A,#15
	OUT	(0xA0),A
	IN	A,(0xA2)
	AND	#0x8F
	OR	#0x30
	LD	(MOUSE_PORT),A
	XOR	A
	LD	(MOUSE_USE),A
	LD	(MOUSE_OFF),A

	LD	A,(MSX_TYPE)
	CP	#3
	JR	Z,INIT_MOUSE_TR

	LD	A,#31
	LD	(MOUSE_WAIT1),A
	LD	A,#10
	LD	(MOUSE_WAIT2),A
	RET
INIT_MOUSE_TR:
	LD	A,#31*5
	LD	(MOUSE_WAIT1),A
	LD	A,#10*5
	LD	(MOUSE_WAIT2),A
	RET



;------------------
MSX_DRV:
	LD	HL,#0x002D
	LD	A,(0xFCC1)
	CALL	0x0C
	LD	(MSX_TYPE),A
	XOR	A
	LD	C,#0x19
	CALL	BDOS
	INC	A
	LD	(CURRENT_DRIVE),A
	RET


D_VELD:		.str	"VELD    SR8"	; VELD DATA 0-255 => GEEN
D_ALL:		.str	"ALL     SR8"
D_ASCII:	.str	"ASCII   SR8"
D_UNIT:		.str	"UNIT    DAT"

D_FIELD_FIL:	.str	"VELDBACK4BP"	; NAAM VAN VELD

CLS:	.db	36,17	; REG 36 , 17 BYTES
	.dw	0	; DX  
	.dw	0	; DY  
	.dw	1024	; NX
	.dw	512	; NY
	.db	0,12	; 0,OPRATIE  
	.dw	0xFFFF	; COLOR MASK  
	.db	0,0	; COLOR  
	.db	0,0	;  
	.db	32	; OPCODE  
