;===============================================================================
; SUB'S
;===============================================================================
; SUB'S
;===============================================================================
; EN SUB'S
;===============================================================================

; B=X
; C=Y

CALC_ADR:
	XOR	A
	LD	HL,#0x4000+1
	SLA	B
	RLA
	SLA	B	; *4
	RLA
	LD	E,B
	LD	D,A	; c'S IN D

	ADD	HL,DE

	SLA	C	; *2
	LD	D,C	; *256
	LD	E,#0
	ADD	HL,DE

	RET

A_TO_IX:
	LD	IX,#TANK1
	RRCA
	RRCA
	RRCA
	RRCA
	LD	C,A

	AND	#0x0F
	LD	B,A

	LD	A,C
	AND	#0xF0
	LD	C,A

	ADD	IX,BC
	RET
A_TO_IY:
	LD	IY,#TANK1
	RRCA
	RRCA
	RRCA
	RRCA
	LD	C,A

	AND	#0x0F
	LD	B,A

	LD	A,C
	AND	#0xF0
	LD	C,A

	ADD	IY,BC
	RET

TNK_TO_IY:
	LD	IY,#TANK_TAB
	SRL	A
	SRL	A
	AND	#0b00111000
	LD	C,A
	LD	B,#0
	ADD	IY,BC
	RET

;=== B:HOEVEEL MENU'S ==HL:WAAR BEGINNEN WE==DE:X,Y


CHK_BUTTON:
	LD	A,D	; X    
	CP	(HL)
	INC	HL
	JR	C,CHK_BUTTON_2

	LD	A,E	; Y    
	CP	(HL)
	INC	HL
	JR	C,CHK_BUTTON_3

	LD	A,D	; X    
	CP	(HL)
	INC	HL
	JR	NC,CHK_BUTTON_4

	LD	A,E	; Y    
	CP	(HL)
	INC	HL
	JR	NC,CHK_BUTTON_5

	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A
	JP	(HL)	; Gevonden dus JP (HL)    

CHK_BUTTON_2:
	INC	HL
CHK_BUTTON_3:
	INC	HL
CHK_BUTTON_4:
	INC	HL
CHK_BUTTON_5:
	INC	HL
	INC	HL
	DJNZ	CHK_BUTTON
	RET





;---------------------------------------------
;
;---------------------------------------------

TYPE_SP0:
	CALL	CAPS_ON
	PUSH	HL
	LD	HL,#SP0_CMD
	CALL	DO_CMD
	POP	HL
TYPE_SP0_2:
	IN	A,(0x65)
	RRCA
	JR	NC,TYPE_SP0_3	; Command ready 

	AND	#0x40
	JR	Z,TYPE_SP0_2	; Transfer not ready 

	LD	A,(HL)	; Get byte from main RAM  
	OUT	(0x62),A	; into VRAM    
	INC	HL

	JR	TYPE_SP0_2
TYPE_SP0_3:
	EI
	CALL	CAPS_OFF
	RET

;---------------------------------------------
; sprite vormpje
;---------------------------------------------

TYPE_SP1:
	PUSH	HL
	LD	HL,#SP1_CMD
	CALL	DO_CMD
	POP	HL
TYPE_SP1_2:
	IN	A,(0x65)
	RRCA
	JR	NC,TYPE_SP1_3	; Command ready

	AND	#0x40
	JR	Z,TYPE_SP1_2	; Transfer not ready

	LD	A,(HL)	; Get byte from main RAM   
	OUT	(0x62),A	; into VRAM     
	INC	HL

	JR	TYPE_SP1_2
TYPE_SP1_3:
	EI
	RET

;---------------------------------------------
; PUTSPRITE0 : BC= X,Y
;---------------------------------------------

PUTSPRITE0:
	IN	A,(0x65)
	RRCA
	JP	C,PUTSPRITE0	; Command ready 

	DI
	XOR	A
	OUT	(0x64),A
	OUT	(0x63),A
	LD	A,#0xFE
	OUT	(0x63),A
	LD	A,#0x07
	OUT	(0x63),A

	LD	A,C
	DEC	A	; SCHOONHEIDS FOUTJE GFX9000
	OUT	(0x60),A	; Y  
	XOR	A
	OUT	(0x60),A
	OUT	(0x60),A	;BITJE 0=Y8  
	OUT	(0x60),A
	LD	A,B
	SLA	A
	OUT	(0x60),A	; X   
	XOR	A
	OUT	(0x60),A
	RL	A
	OR	#0x40
	OUT	(0x60),A	; X 
	EI
	RET

;---------------------------------------------
; H_PUTSPRITE1 : BC= X,Y
;---------------------------------------------

PUTSPRITE1:
	DI
	XOR	A
	OUT	(0x64),A
	LD	A,#0x08
	OUT	(0x63),A
	LD	A,#0xFE
	OUT	(0x63),A
	LD	A,#0x07
	OUT	(0x63),A

	LD	A,C
	DEC	A	; FOUTJE GFX9000
	OUT	(0x60),A	; Y   
	XOR	A
	OUT	(0x60),A
	OUT	(0x60),A	;BITJE 0=Y8   
	OUT	(0x60),A
	LD	A,B
	SLA	A
	OUT	(0x60),A	; X   
	LD	A,#0
	OUT	(0x60),A
	RL	A
	OR	#0x40
	OUT	(0x60),A	; X 
	EI
	RET



;---------------------------------------------
; DO_CMD : commandows sturen naar de GFX
; IN: HL= pionter naar tabel die naar GFX gaat
;---------------------------------------------

DO_CMD:
	;CALL	COLOR_BLAU
DO_CMD1:
	IN	A,(0x65)
	RRCA
	JR	C,DO_CMD	; wacht op tot cmd is afgelopen

	;CALL	COLOR_BLACK
	DI

	LD	A,(HL)
	OUT	(0x64),A	; reg nr. 
	INC	HL
	LD	B,(HL)	; hoeveel bytes 
	INC	HL
	LD	C,#0x63

	OTIR
	EI
	RET

COLOR_BLACK:
	LD	A,#15	; de border color 
	OUT	(0x64),A
	XOR	A	; 0*1 
	OUT	(0x63),A	; COLOR #0    ( R 14 )   
	RET
COLOR_WHITE:
	LD	A,#15
	OUT	(0x64),A
	LD	A,#1*4
	OUT	(0x63),A	; COLOR #1    ( R 14 ) 
	RET

COLOR_RED:
	LD	A,#15
	OUT	(0x64),A
	LD	A,#2*4
	OUT	(0x63),A	; COLOR #2    ( R 14 ) 
	RET
COLOR_GREEN:
	LD	A,#15
	OUT	(0x64),A
	LD	A,#3*4
	OUT	(0x63),A	; COLOR #3    ( R 14 ) 
	RET
COLOR_BLAU:
	LD	A,#15
	OUT	(0x64),A
	LD	A,#4*4
	OUT	(0x63),A	; COLOR #4    ( R 14 ) 
	RET
CAPS_ON:
	IN	A,(0xAA)
	AND	#0xBF
	OUT	(0xAA),A
	RET
CAPS_OFF:
	IN	A,(0xAA)
	OR	#0x40
	OUT	(0xAA),A
	RET

;-------------
; BIOS ROUTINS

PUT_INT:
	DI
	LD	DE,#0x38+1

	LD	A,(HL)
	LD	(DE),A
	INC	DE
	INC	HL
	LD	A,(HL)
	LD	(DE),A
	RET
GET_INT:
	DI
	LD	DE,#0x38+1

	LD	A,(DE)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	LD	(HL),A
	RET
