ENASLT 		.equ	0x24
DOS 		.equ	0x5
BDOS 		.equ	0x5
D_OPEN 		.equ	0x0F
D_SETDMA 	.equ	0x1A
D_READ 		.equ	0x27
D_CLOSE 	.equ	0x10
D_WRITE 	.equ	0x26
D_CREATE 	.equ	0x16

_CONOUT		.equ	0x02

.area	_CODE

;---------------------------------------------
; De echte hoofd routine van DOME
;---------------------------------------------
ST:
	LD	(EXIT_STACK),SP
	;CALL	DEMO
	;RET

	CALL	INIT_DOME
	EI
	HALT
MAIN:
	LD	A,(FIRE_BUTTONS)
	BIT	4,A
	CALL	Z,CHK_MOUSE_LEFT

	LD	A,(FIRE_BUTTONS)
	BIT	5,A
	CALL	Z,CHK_MOUSE_RIGHT

	LD	A,(KEYS_TAB+8)
	BIT	0,A
	JP	Z,EXIT_DOME2

	CALL	UPDATE_EVENT

	JR	MAIN

UPDATE_EVENT:
	LD	A,(EVENT)
	INC	A
	CP	#6
	JR	NZ,UPD2
	XOR	A
UPD2:
	LD	(EVENT),A
	LD	HL,#EVENTHANDLER
	SLA	A
	LD	C,A
	LD	B,#0
	ADD	HL,BC
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	JP	(HL)

EVENT:
	.db	0
EVENTHANDLER:
	.dw	BUILD	; GFX
	.dw	AI
	.dw	CHK_XY	; GFX
	.dw	INIT_RADAR ; GFX
	.dw	UPDATE	; GFX
	.dw	ALGEMEEN


;---------------------------------------------
; H_EXIT_DOME : terug naar basic op elk moment
;---------------------------------------------

EXIT_DOME:
	CALL	D_FIELD_SAVE
EXIT_DOME2:
	EI
	HALT

	LD	A,#0x10	; show msx for video9000
	OUT	(0x6F),A

	LD	HL,#INT_DOS
	CALL	PUT_INT
	LD	SP,(EXIT_STACK)	; stack terug

	EI
	HALT
	HALT

	ld	e,#':'
	ld	c,#_CONOUT
	call	5

	ld	e,#')'
	ld	c,#_CONOUT
	call	5

	ld	e,#'\n'
	ld	c,#_CONOUT
	call	5

	ld	e,#'\r'
	ld	c,#_CONOUT
	call	5

	RET		; ECHT TERUG NAAR DOS






	.include 	"build.asm"
	.include 	"update.asm"
	.include 	"mouse.asm"
	.include 	"ai.asm"
	.include 	"disk.asm"
	.include 	"int.asm"
	.include 	"init.asm"
	.include 	"subs.asm"
	.include 	"tanktab.asm"





DEMO:
	XOR	A	; 2=MIXMODE 
	OUT	(0x6F),A
	OUT	(0x67),A	; POWER OFF + INT CLK

	LD	A,#6	; SETREG 
	OUT	(0x64),A
	LD	A,#0b10011010	;ITMAP,XTAL,212DOTS,8BIT
	OUT	(0x63),A
	LD	A,#0b00001000	;0,B,262,?,PAL,INTER,INTERLACE,MODE 
	OUT	(0x63),A
	LD	A,#0b10000010	; VRAM,SPRITE,YS,0,0,DREQ,512KB 
	OUT	(0x63),A

	LD	A,#13
	OUT	(0x64),A
	LD	A,#0b01000000	; 256  COLOR-MODE
	OUT	(0x63),A

DEMO1:
	IN	A,(0x65)
	AND	#64
	JR	NZ,DEMO1
DEMO2:
	IN	A,(0x65)
	AND	#64
	JR	Z,DEMO2

	LD	A,#17
	OUT	(0x64),A
	XOR	A	; LIJN 0 ( MOET OP V-INT) 
	LD	B,#8
DEMO3:
	OUT	(0x63),A	; ALLES OP 0
	DJNZ	DEMO3

	LD	HL,#NAM_DEMO
	CALL	GETNAM

	CALL	OPEN
	LD	DE,#0x8000
	CALL	SETDMA

	LD	HL,#56
	CALL	READ	; HEADER

	LD	HL,#GFX_CMD2
	CALL	DO_CMD

	LD	B,#7
DEMO4:
	PUSH	BC

	LD	DE,#0x8000
	CALL	SETDMA

	LD	HL,#0x3FFF
	CALL	READ

	LD	BC,#0x3FFF
	LD	HL,#0x8000
DEMO5:
	LD	B,#1	
	IN	A,(0x65)
	RRCA
	JR	NC,DEMO6	; Command ready  

	AND	#0x40
	JR	Z,DEMO5	; Transfer not ready  

	LD	A,(HL)	; Get byte from main RAM   
	OUT	(0x62),A	; into VRAM   

	INC	HL
	DEC	BC

	LD	A,B
	OR	C
	JR	NZ,DEMO5
DEMO6:
	POP	BC
	DJNZ	DEMO4

	LD	A,#0x34
	OUT	(0x64),A
	XOR	A
	OUT	(0x63),A

	CALL	CLOSE

	EI
	HALT
	HALT
	HALT
	HALT

	RET

GFX_CMD2:
	.db	36,17	; REG 36 , 17 BYTES
	.dw	0	; DX  
	.dw	0	; DY
	.dw	512	; NX  
	.dw	212	; NY  
	.db	0,12	; 0,OPRATIE   
	.dw	0xFFFF	; COLOR MASK   
	.db	0,0	; COLOR   
	.db	0,0	;   
	.db	16	; OPCODE  



NAM_DEMO:
	.str	"TARA    BMP"


;---------------------------------------------
; H_INIT_RADAR : init radar schermpje
;---------------------------------------------

	.db	255
INIT_RADAR:
	LD	A,(INIT_RADAR-1)
	INC	A
	LD	(INIT_RADAR-1),A
	OR	A
	;JR	Z,MAKE_RADAR
	RET

MAKE_RADAR:
	LD	HL,#INIT_RAD_CMD
	CALL	DO_CMD
	LD	HL,#0x4001	; GEEN INC HL ???
MAKE_RADAR_LP:
	IN	A,(0x65)
	RRCA
	JR	NC,MAKE_RADAR_RD	; Command ready

	AND	#0x40
	JR	Z,MAKE_RADAR_LP	; Transfer not ready

	LD	A,(HL)	; Get byte from main RAM 
	AND	#0xF0
	CALL	MAKE_RADAR_CL
	OUT	(0x62),A	; into VRAM   

	INC	HL
	INC	HL
	INC	HL
	INC	HL

	JR	MAKE_RADAR_LP
MAKE_RADAR_RD:
	LD	HL,#COPY_RADAR
	CALL	DO_CMD
	EI
	RET

MAKE_RADAR_CL:
	EX	DE,HL
	LD	HL,#MAKE_RADAR_TAB
	LD	C,A
	LD	B,#0
	ADD	HL,BC
	LD	A,(HL)
	EX	DE,HL
	RET
MAKE_RADAR_TAB:
	.db	145
	.db	4
	.db	9
	.db	16

	.db	25
	.db	36
	.db	49
	.db	64

	.db	81
	.db	100
	.db	121
	.db	144

	.db	169
	.db	196
	.db	225
	.db	255


INIT_RAD_CMD:
	.db	36,17	; REG 36 , 17 BYTES
	.dw	384	; DX
	.dw	8	; DY
	.dw	128	; NX
	.dw	64	; NY
	.db	0,12	; 0,OPRATIE
	.dw	0xFFFF	; COLOR MASK
	.db	0,0	; COLOR    
	.db	0,0	;    
	.db	16	; OPCODE   

COPY_RADAR:
	.db	32,21
	.dw	384	; SX
	.dw	8	; SY
	.dw	384+512	; DX
	.dw	8	; DY
	.dw	128	; NX
	.dw	64	; NY
	.db	0,12	; 0,OPRATIE  
	.dw	0xFFFF	; COLOR MASK      
	.db	0,0	; COLOR      
	.db	0,0	;      
	.db	64	; OPCODE

TEST_DB:

END:
.area	_DATA
